;-----------------------------------------------------------------------------------
; BareNumbersOS v.0.3 - GPL3 - Aug 2012
;
;-----------------------------------------------------------------------------------
; 64 bit support
;-----------------------------------------------------------------------------------


RM_Check_64:
; Check to make sure the CPU supports 64-bit mode... If not then bail out
	mov eax, 0x80000000		; Extended-function 8000000h.
	cpuid				; Is largest extended function
	cmp eax, 0x80000000		; any function > 80000000h?
	jbe near no_long_mode		; If not, no long mode.
	mov eax, 0x80000001		; Extended-function 8000001h.
	cpuid				; Now EDX = extended-features flags.
	bt edx, 29			; Test if long mode is supported.
	jnc near no_long_mode		; Exit if not supported.

	ret

; Display an error message that the CPU does not support 64-bit mode
no_long_mode:
	mov ax, 480+7			;start point
	mov ch,' '			;color
	mov bx, msg_no64		;str
	call RM_PutStr
	hlt				; halt cpu
	jmp $


; =============================================================================
; EOF
