;-----------------------------------------------------------------------------------
; BareNumbersOS v.0.3 - GPL3 - Aug 2012
;
;-----------------------------------------------------------------------------------
; Infomap
;-----------------------------------------------------------------------------------

table_m dd 1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 3072, 4096, 6144, 8192, 10240, 12288, 16384, 32768, 65536, 131072, 262144, 524288

total_m 		dq 0
base_m			dq 0
lenght_m 		dq 0
type_m			dd 0

LM_Init_Infomap:

	mov rsi, 0x0000000000004000	; E820 Map location
.tablemem:
	mov rax, [rsi + 0]
	mov [base_m], rax
	mov rax, [rsi + 8]
	mov [lenght_m], rax
	mov eax, [rsi + 16]
	mov [type_m], eax
	
	cmp eax, 0			; Are we at the end?
	je .endmem

	mov rcx, [lenght_m]		
	cmp rcx, 0			; Check if zero
	je .nextmem

	cmp [type_m], 1			; if not usable then skip
	jne .nextmem
	
	add [total_m], rcx

.nextmem:
	add rsi, 32
	jmp .tablemem
.endmem:

;-----------------------------
	; Calculate ram in Mib
	xor rax, rax
	xor rbx, rbx
	xor rcx, rcx

	mov rax, [total_m]
	shr rax, 20			; div 1024*1024

	; Roundup ram
.repeat:
	mov ecx, dword [table_m + ebx]
	add ebx, 4
	cmp eax, ecx
	ja .repeat
	mov [mem_amount], ecx

	; Print message
	;--------------
	mov ax, 0+7
	mov bx, 6
	mov ch, ' '
	mov dx, 80
	mov rsi, msg_mem
	call LM_WriteTextString

	xor edx, edx
	mov edx, [mem_amount]
	mov ax, 25
	mov bx, 6
	mov ch,' '
	call LM_Write_TXT_HEX32

; Build the infomap
	mov rdi, 0x0000000000005000
	mov rax, [os_LocalAPICAddress]
	stosq
	mov rax, [os_IOAPICAddress]
	stosq

	mov rdi, 0x0000000000005010
	mov ax, [cpu_speed]		; not used
	stosw
	mov ax, [cpu_activated]
	stosw
	mov ax, [cpu_detected]
	stosw

	mov rdi, 0x0000000000005020
	mov eax, [mem_amount]
	stosd

	mov rdi, 0x0000000000005030
	mov al, [cfg_mbr]		; not used
	stosb
	mov al, [GUI]
	stosb

	mov rdi, 0x0000000000005040
	mov rax, [os_ACPITableAddress]
	stosq

	mov rdi, 0x0000000000005050
	mov rax, Vesa_info
	stosq
	mov rax, Vesa_modeinfo
	stosq
	mov ax, [VESAMODE]
	stosw
	mov al, [IDMODE]
	stosb

ret

; ===================================================================================================
; EOF

