;-----------------------------------------------------------------------------------
; BareNumbersOS v.0.3 - GPL3 - Aug 2012
;
;-----------------------------------------------------------------------------------
; Reset APs
;-----------------------------------------------------------------------------------


K_Reset_ap:

	; Initialize all AP's to run our reset code. Skip the BSP
	xor rax, rax
	xor rcx, rcx
	mov rsi, 0x0000000000005700	; Location in memory of the Sys64 CPU data

next_ap:
	cmp rsi, 0x0000000000005800	; Enable up to 256 CPU Cores
	je no_more_aps
	lodsb				; Load the CPU parameters
	bt rax, 0			; Check if the CPU is enabled
	jnc skip_ap
	bt rax, 1			; Test to see if this is the BSP (Do not init!)
	jc skip_ap
	mov rax, rcx
	call os_smp_reset		; Reset the CPU
skip_ap:
	add rcx, 1
	jmp next_ap

no_more_aps:

ret


; ===================================================================================================
; EOF
